/*

 Ŀ
       cRYPTO-kEYGENME 3 by bLaCk-eye                  
                                                       
  cracked by  :        bF! / K23 / TKM!                
  protected by:        whirlpool, modular arithmetics  
 
   

  protection:

  whirlpoolhash(name)(512bits) is divided in two equal
  parts (256bit), h1 and h2, which are then used in the
  rest of equation (^ is xor):

     p=[next_prime(h1 ^ h2)], check if p mod 3 = 1

  then comes final condition (^ is power off):

     activation^2 + 3*serial^2 = p

  I'm using Cornacchia algorithm to solve this
  Diophantine equation (thanks to haldir for pointing it
  out). Also I'm using freelip and miracle libraries for
  big number calculations.
  
  Whirlpool hash source is not included due to it's size
  and size limit on crackmes.de, you can find it online.
________________________________________________________

  Cornacchia algorithm implementation details:
________________________________________________________

  Author:  Pate Williams (c) 1997

  Algorithm 1.5.2 (Cornacchia). See "A Course in
  Computational Algebraic Number Theory" by Henri
  Cohen pages 34 - 35. Let p be a prime number
  and 0 < d < p, this algorithm either outputs
  an integer solution (x, y) to the Diophantine
  equation x * x + d * y * y = p, or says that
  such a solution does not exist.
________________________________________________________

  greets:
  blacky, haldir, blunapalm, tkm!... everyone!

  mail me for anything at: marios_crk@yahoo.co.uk

                               Ŀ
                                  bF! / K23 / TKM!   
                                   - fall 2004 -     
                               
                                 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lip.h"
#include "Whirlpool.h"
#include "Miracl.h"

int square_test(verylong zn, verylong *zq)
{
  int square = 1;
  long q11[11], q63[63], q64[64], q65[65];
  long k, r, t;
  verylong zd = 0;

  for (k = 0; k < 11; k++) q11[k] = 0;
  for (k = 0; k < 6; k++) q11[(k * k) % 11] = 1;
  for (k = 0; k < 63; k++) q63[k] = 0;
  for (k = 0; k < 32; k++) q63[(k * k) % 63] = 1;
  for (k = 0; k < 64; k++) q64[k] = 0;
  for (k = 0; k < 32; k++) q64[(k * k) % 64] = 1;
  for (k = 0; k < 65; k++) q65[k] = 0;
  for (k = 0; k < 33; k++) q65[(k * k) % 65] = 1;
  t = zsmod(zn, 64l);
  r = zsmod(zn, 45045);
  if (q64[t] == 0) square = 0;
  if (square && q63[r % 63] == 0) square = 0;
  if (square && q65[r % 65] == 0) square = 0;
  if (square && q11[r % 11] == 0) square = 0;
  if (square) {
    zsqrt(zn, zq, &zd);
    if (zscompare(zd, 0l) != 0) square = 0;
  }
  zfree(&zd);
  return square;
}

int Cornacchia(verylong zd, verylong zp,
               verylong *zx, verylong *zy)
{
  int value;
  verylong zD = 0, za = 0, zb = 0, zc = 0, zl = 0;
  verylong zr = 0, zx0 = 0;

  zcopy(zd, &zD);
  znegate(&zD);
  if (zjacobi(zD, zp) != - 1) {
    zadd(zD, zp, &za);
    zsqrtmod(za, zp, &zx0);
    zrshift(zp, 1l, &za);
    zcopy(zx0, &zc);
    while (zcompare(zx0, za) <= 0) {
      zadd(zx0, zp, &zb);
      zcopy(zb, &zx0);
    }
    if (zcompare(zx0, zp) >= 0) {
      zcopy(zc, &zx0);
      znegate(&zx0);
      while (zcompare(zx0, za) <= 0) {
        zadd(zx0, zp, &zb);
        zcopy(zb, &zx0);
      }
    }
    zcopy(zp, &za);
    zcopy(zx0, &zb);
    zsqrt(zp, &zl, &zc);
    while (zcompare(zb, zl) > 0) {
      zmod(za, zb, &zr);
      zcopy(zb, &za);
      zcopy(zr, &zb);
    }
    zsq(zb, &za);
    zsub(zp, za, &zD);
    zdiv(zD, zd, &zc, &zr);
    if (zscompare(zr, 0l) == 0 && square_test(zc, &za)) {
      zcopy(zb, zx);
      zcopy(za, zy);
      value = 1;
    }
    else value = 0;
  }
  else value = 0;
  zfree(&zD);
  zfree(&za);
  zfree(&zb);
  zfree(&zc);
  zfree(&zl);
  zfree(&zr);
  zfree(&zx0);
  return value;
}

int main(void)
{
  miracl *mMiracl;
  char szName[30], NextPrime[100], szActivation[100], szSerial[100], temp[100];
  int pr, namelen;
  verylong zd = 0, zp = 0, zx = 0, zy = 0, h1 = 0, h2 = 0, hxor = 0;
  big a, b, resc, one;

  // header
  static char lpHeader[]=" Ŀ\n"
                         "       cRYPTO-kEYGENME 3 by bLaCk-eye                  \n"
                         "                                                       \n"
                         "  cracked by  :        bF! / K23 / TKM!                \n"
                         "  protected by:        whirlpool, modular arithmetics  \n"
                         " \n"
                         "   \n\n";
  printf(lpHeader);
  // name input
  printf(" Name: ");
  scanf("%32s",&szName);

  // hash the name
  namelen = strlen(szName);
  makeISOTestVectors(szName, namelen);

  // convert to big
  zstrtozbas(WhirlHash1,16,&h1);
  zstrtozbas(WhirlHash2,16,&h2);

  // hxor = h1 xor h2
  zxor(h1,h2,&hxor);

  // write big decimal as string
  zswrite(NextPrime,hxor);

  // from now we mix miracl and freelip (don't ask why ;-)
  mMiracl = mirsys(512,0);
  mMiracl -> IOBASE = 10;

  a = mirvar(0); b = mirvar(3); resc = mirvar(0); one = mirvar(1);
  
  cinstr(a,NextPrime);
  while (compare(resc,one) != 0){
  // next prime > hxor
  nxprime(a, a);
  // nxprime mod 3 ?= 1
  power(a,1,b,resc);
  }

  cotstr(a,NextPrime);

  zstrtozbas(NextPrime,10,&zp);

  printf("\n p = ");
  zswrite(temp,zp);
  cinstr(a,temp);
  // go to base 16 just for output
  mMiracl -> IOBASE = 16;
  cotnum(a,stdout);

  // is p a prime number
  pr = zprobprime(zp, 10);
  if (!pr) {
           printf("\n *ERROR*\n p must be a prime\n");
           printf(" no solution for your name\n\n");
           return 0;
  }

  // back to base 10
  mMiracl -> IOBASE = 10;

  printf(" d = ");
  // d = 3
  zintoz((long int) 3, &zd);
  zwriteln(zd);

  printf("\n Trying to solve Diophantine equation x * x + d * y * y = p ...\n\n");

    if (Cornacchia(zd, zp, &zx, &zy)) {
                // print out the results
				zswrite(szActivation,zx);
                zswrite(szSerial,zy);
                cinstr(a,szActivation);
                cinstr(b,szSerial);
                printf(" Activation: ");
				//display in base16
				mMiracl -> IOBASE = 16;
                cotnum(a, stdout);
                printf(" Serial: ");
                cotnum(b, stdout);
				printf("\n");
    }
    else printf(" Diophantine equation has no solution, no serial for your name!\n");

  // deinit everything
  mirkill(a);
  mirkill(b);
  mirkill(resc);
  mirkill(one);
  zfree(&zd);
  zfree(&zp);
  zfree(&zx);
  zfree(&zy);
  zfree(&h1);
  zfree(&h2);
  zfree(&hxor);

  // pause so we can see results
  system("PAUSE");

  return 0;
}
